*******************************************************************************
* Project:	ultraSTE
* Module:	3d
* Code:		ultra
* Created:	18.05.2021
* Notes:	
* Modified:
* Changes:
*
* (c) 2021 cream
*******************************************************************************

	include	"US3dCamera.s"
	include "US3dObject.s"

US3dStartCalc:
; starts the fpga 3d calculation
; use US3dBusy to check if the fpga is done
; of course a start calc makes only sense if you
; transfered the scene to the fpga before
;
; current calculation time it's not possible to access
; the result of the 3d calculation.

	USWrReg	#0,US3dStartCalcR
	rts
*******************************************************************************
US3dGetMinMax:
; gets after a 3d calc the min and max values from x and y
; for clearing the screen.
; DO NOT CALL DURING A processing 3D CALC!
;
; d0 <- minX
; d1 <- maxX
; d2 <- minY
; d3 <- maxY

	USRdReg USMinX,d0	;minX
	USRdReg USMaxX,d1	;minX
	USRdReg USMinY,d2	;minX
	USRdReg USMaxY,d3	;minX
	rts

*******************************************************************************
US3dWaitBusy:
; checks if the fpga has finished 3d calculation
	USRdReg US3dBusyCalcR,d0
	bne.s	US3dWaitBusy
	rts

*******************************************************************************
US3dSelectFace:
; d0 -> face
	USWrReg	d0,US3dSelectFaceR
	rts

*******************************************************************************
US3dCalcFaceData:
	USWrReg	#0,US3dCalcFaceDataR
	rts

*******************************************************************************
US3dGetFace:
	USSelReg US3dGetFaceR
	rts

*******************************************************************************
US3dSetScreenSize:
; mainly used for centre of the 3d points and to recognise if a 
; poly needs to be clipped
; d0 x size
; d1 y size
	move	d0,us3dscreenXSave
	move	d1,us3dscreenYSave
	movem.l	d0-d1,-(a7)
	subq	#1,d0
	subq	#1,d1
	move	d0,us3dscreenXSave_1
	move	d1,us3dscreenYSave_1
	movem.l	(a7)+,d0-d1
	lsr	#1,d0
	lsr	#1,d1

	USWrReg d0, US3dScreenX
	USWrReg d1, US3dScreenY
	rts
us3dscreenXSave:	dc.w	160
us3dscreenYSave:	dc.w	100
us3dscreenXSave_1:	dc.w	160
us3dscreenYSave_1:	dc.w	100

*******************************************************************************

