*******************************************************************************
* Project:	ultraSTE
* Module:	color tables
* Code:		ultra
* Created:	11.04.2021
* Notes:	
* Modified:
* Changes:
*
* (c) 2021 cream
*******************************************************************************

USSetColors1FromBmp:
;sets all colors for color table 1 from bmp
;-> a0 pointer to bmp data
	move	#USColorTable1R,d0
	jsr	USSetColorsFromBmp
	rts

*******************************************************************************
USSetColors2FromBmp:
;sets all colors for color table 2 from bmp
;-> a0 pointer to bmp data
	move	#USColorTable2R,d0
	jsr	USSetColorsFromBmp
	rts

*******************************************************************************
USSetColors3FromBmp:
;sets all colors for color table 2 from bmp
;-> a0 pointer to bmp data
	move	#USColorTable3R,d0
	jsr	USSetColorsFromBmp
	rts

*******************************************************************************
USSetColorsFromBmp:
;-> a0 pointer to bmp data
	move	d0,USRegSelect
	jsr	BmpGetColorTable

	moveq	#0,d2
.USSetColorsLoopBmp:
	moveq	#0,d0
	move.b	(a0)+,d1
	move.b	(a0)+,d0
	lsl	#8,d0
	or.b	d1,d0
	
	moveq	#0,d1
	move.b	(a0)+,d1
	lea	1(a0),a0
	move	d1,USRegData
	move	d0,USRegData

	addq	#1,d2
	cmp	#$100,d2
	bne.s	.USSetColorsLoopBmp
	rts

*******************************************************************************
USSetColors:
;-> a0 act color table from photoshop
;-> d0 start color
	move	d0,USRegSelect
	moveq	#0,d2
.USSetColorsLoop:
	move.b	(a0)+,d0
	and	#$ff,d0
	move.w	d0,USRegData

	move.b	(a0)+,d0
	lsl	#8,d0
	move.b	(a0)+,d0
	move	d0,USRegData

	addq	#1,d2
	cmp	#$100,d2
	bne.s	.USSetColorsLoop
	rts

*******************************************************************************
USSetColorsFadeBlack:
;-> a0 act color table from photoshop
;-> d0 start color
;-> d1 brightness 0 dark $ff full
	
	move	d0,USRegSelect
	eor.b	#$ff,d1
	and	#$ff,d1
	move	#$100-1,d2
.USSetColorsLoop2:
	move.b	(a0)+,d0
	and	#$ff,d0
	sub	d1,d0
	bpl.s	.no1
	moveq	#0,d0
.no1:
;	and	#$ff,d0
	move.w	d0,USRegData

	move.b	(a0)+,d0
	and	#$ff,d0
	sub	d1,d0
	bpl.s	.no2
	moveq	#0,d0
.no2:
	lsl	#8,d0

	move.b	(a0)+,d3
	and	#$ff,d3
	sub	d1,d3
	bpl.s	.no3
	moveq	#0,d3
.no3:
	move.b	d3,d0
	move	d0,USRegData
	dbf	d2,.USSetColorsLoop2
;	addq	#1,d2
;	cmp	#$100,d2
;	bne.s	.USSetColorsLoop2
	rts
*******************************************************************************
USSetColorsFadeWhite:
;-> a0 act color table from photoshop
;-> d0 start color
;-> d1 brightness 0 dark $ff full
	move	d0,USRegSelect
	and	#$ff,d1
	move	#$100-1,d2
.USSetColorsLoop2:
	move.b	(a0)+,d0
	add.b	d1,d0
	bcc.s	.no1
	moveq	#-1,d0
.no1:
	move.w	d0,USRegData

	move.b	(a0)+,d0
	add.b	d1,d0
	bcc.s	.no2
	moveq	#-1,d0
.no2:
	lsl	#8,d0

	move.b	(a0)+,d3
	add.b	d1,d3
	bcc.s	.no3
	moveq	#-1,d3
.no3:
	move.b	d3,d0
	move	d0,USRegData
	dbf	d2,.USSetColorsLoop2
;	addq	#1,d2
;	cmp	#$100,d2
;	bne.s	.USSetColorsLoop2
	rts