*******************************************************************************
* Project:	ultraSTE
* Module:	Display
* Code:		ultra
* Created:	20.04.2021
* Notes:	
* Modified:
* Changes:
*
* (c) 2021 cream
*******************************************************************************

*******************************************************************************
USSetDisplayMode:
; sets the display mode. to use the new modes you have to switch to low res before!
; 
;d0 display mode
; x0	normal st
; x1	2x1 256 colors
; m2	2x2 256 colors 2 layers (add) -> USColorTable1R & USColorTable2R
; x3	320x200 area fill mode -> USColorTable3R
; x4	160x100 1x1 mode -> USColorTable1R
;
; x don't care
; m mode:
; 0x = add
; 1x = sub
; 2x = overlay
	USWrReg d0,USDisplayModeR
	rts

*******************************************************************************
USSetFadeOutL1:
;d0 fade out value for layer 1
; fades all colors of layer 1 to black
; $00 black
; $ff full brightness
	move	d0,USDisplayL1BrSave
	USWrReg d0,USFadeToBlack1R
	rts
USDisplayL1BrSave:
	dc.w	0
*******************************************************************************
USSetFadeOutL2:
;d0 fade out value for layer 2
; fades all colors of layer 2 to black
; $00 black
; $ff full brightness
	move	d0,USDisplayL2BrSave

	USWrReg d0,USFadeToBlack2R
	rts
USDisplayL2BrSave:
	dc.w	0

*******************************************************************************
USSetFadeToWhite:
;d0 fade to white value for all layers
; fades all colors of all layers to white
; $00 normal
; $ff full white

	USWrReg d0,USFadeToWhiteR
	rts

*******************************************************************************
USSetAllBlack:
;fades out all layers to black and setting white to normal
	moveq	#0,d0
	bsr	USSetFadeOutL1
	bsr	USSetFadeOutL2
	USWrReg	d0,USFadeToBlack3

	bsr	USSetFadeToWhite
	rts
*******************************************************************************
USResetFades:
;resets all fades to default
	move	#$ff,d0
	bsr	USSetFadeOutL1
	bsr	USSetFadeOutL2
	move	#$0,d0
	bsr	USSetFadeToWhite
	rts

*******************************************************************************
USResetAll:
	USWrReg #0,USDisplayModeR
	jsr	USResetFades
	rts

*******************************************************************************
USSetFake1x2:
; not supported anymore maybe in future
; d0[0] = 0 == off 1 == on
	move	#USSetFake1x2R,USRegSelect
	move	d0,USRegData
	rts

*******************************************************************************
USDetermineC2pStart:
; this is very important on real hardware. if you do not call
; the display is messed up!
;
; call in supervisor mode
; determines the screen start

	;//reset shifter ...switch shortly to 60hz and back to 50hz
;	move	#0,$ffff820a.w

;	move	#10683,d0
;.USDetermineC2pStartWait3:
;	move.l	(a0,d1),d2
;	dbf	d0,.USDetermineC2pStartWait3

;	move	#1,$ffff820a.w

	move.w	#$0000,-(sp)
	move.l	$44e,-(sp)
	move.l	$44e,-(sp)
	move.w	#5,-(sp)
	trap	#14
	adda.l	#12,sp

	move	#$000,$ffff8240.w
	move	#$f00,$ffff8242.w

	;// write one pixel to screen
	;// the pixel is used to find the startposition of the hor screen.
	move.l	$44e,a0
	move	#$8000,(a0)

	;// switch to screen start mode
	move	#USDisplayModeR,USRegSelect
	move	#15,USRegData

	;//wait about 2 vbls
	move	#0,d1
	move	#10683,d0
.USDetermineC2pStartWait2:
	move.l	(a0,d1),d2
	dbf	d0,.USDetermineC2pStartWait2
	
	move	#0,d1
	move.l	$44e,a0

	;//wait about 2 vbls
	move	#10683,d0
.USDetermineC2pStartWait:
	move.l	(a0,d1),d2
	dbf	d0,.USDetermineC2pStartWait

	;// switch back to normal st mode
	
	move	#USDisplayModeR,USRegSelect
	move	#2,USRegData
	rts


