*******************************************************************************
* Project:	ultraSTE
* Module:	draw scene with lines
* Code:		ultra
* Created:	04.03.2022
* Notes:	routines for drawing the calculated data in lines.
*		the lines are used for the area fill more
* Modified:
* Changes:
*
* (c) 2022 cream
*******************************************************************************
USDrawSceneLines:
;-> a0 	screen address to draw to
;-> d0	line bytes
	move.l	a0,a6

	; set screen and and row bytes
	USWrReg	d0,US3dLineBytesPerLine
	move.l	a0,d0
	USWrReg	d0,US3dLineScreenAdrLo
	swap	d0
	USWrReg	d0,US3dLineScreenAdrHi

	bsr	US3dGetVisibleFaces
	tst	d0
	beq	.done
	;// start calc for the first face
	USWrReg	#0,US3dCalcLineData
	bsr	US3dWaitBusy
	USWrReg	#0,US3dGetLineData
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	lea	US3dResultData,a0
.drawLoop:
	;// get color (User1 from the face list) not used yet
	;// this is if someone wants to build a 16 color line routine
	move	(a0),d0		; get user1 from face

	;// draw first line of the face
	;// lines are drawn clock wise
	move	(a0),d0		; get line len
	bmi.s	.done
	beq.s	.nextLine2	; line not visible or len = 0
	lea	USLineDrawline(pc),a4
	sub	d0,a4
	jsr	(a4)

.nextLine2:
	;// draw second line of the face
	move	(a0),d0		; get line len
	beq.s	.nextLine3	; line not visible or len = 0
	lea	USLineDrawline(pc),a4
	sub	d0,a4
	jsr	(a4)
.nextLine3:
	;// draw third line of the face
	move	(a0),d0		; get line len
	

	beq.s	.nextLine4	; line not visible or len = 0
	lea	USLineDrawline(pc),a4
	sub	d0,a4
	jsr	(a4)
.nextLine4:
	nop			;give the fpga some time to calc
	nop			;next face
	nop
	nop
	nop
	bra	.drawLoop
.done:
	rts
*******************************************************************************
	rept	230
	move.l	(a0),a2		; get screen adresse
	move	(a0),d1		; get screen value
	eor	d1,(a2)		; draw to screen
	endr
USLineDrawline:
	rts